'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _mergeCmd;

function _load_mergeCmd() {
  return _mergeCmd = require('./merge-cmd');
}

var _mergeVersion;

function _load_mergeVersion() {
  return _mergeVersion = require('../../../consumer/versions-ops/merge-version');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkout = function (_Command) {
  _inherits(Checkout, _Command);

  function Checkout() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Checkout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Checkout.__proto__ || Object.getPrototypeOf(Checkout)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'checkout [values...]', _this.description = `switch between component versions
  bit checkout <version> [ids...] => checkout the specified ids (or all components when --all is used) to the specified version
  bit checkout latest [ids...] => checkout the specified ids (or all components when --all is used) to their latest versions
  bit checkout [ids...] --reset => remove local modifications from the specified ids (or all components when --all is used)`, _this.alias = 'U', _this.opts = [['i', 'interactive-merge', 'when a component is modified and the merge process found conflicts, display options to resolve them'], ['o', 'ours', 'in case of a conflict, override the used version with the current modification'], ['t', 'theirs', 'in case of a conflict, override the current modification with the specified version'], ['m', 'manual', 'in case of a conflict, leave the files with a conflict state to resolve them manually later'], ['r', 'reset', 'remove local changes'], ['a', 'all', 'all components'], ['v', 'verbose', 'showing verbose output for inspection'], ['', 'skip-npm-install', 'do not install packages of the imported components'], ['', 'ignore-dist', 'do not write dist files (when exist)']], _this.loader = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Checkout, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          values = _ref4[0];

      var _ref3$interactiveMerg = _ref3.interactiveMerge,
          interactiveMerge = _ref3$interactiveMerg === undefined ? false : _ref3$interactiveMerg,
          _ref3$ours = _ref3.ours,
          ours = _ref3$ours === undefined ? false : _ref3$ours,
          _ref3$theirs = _ref3.theirs,
          theirs = _ref3$theirs === undefined ? false : _ref3$theirs,
          _ref3$manual = _ref3.manual,
          manual = _ref3$manual === undefined ? false : _ref3$manual,
          _ref3$reset = _ref3.reset,
          reset = _ref3$reset === undefined ? false : _ref3$reset,
          _ref3$all = _ref3.all,
          all = _ref3$all === undefined ? false : _ref3$all,
          _ref3$verbose = _ref3.verbose,
          verbose = _ref3$verbose === undefined ? false : _ref3$verbose,
          _ref3$skipNpmInstall = _ref3.skipNpmInstall,
          skipNpmInstall = _ref3$skipNpmInstall === undefined ? false : _ref3$skipNpmInstall,
          _ref3$ignoreDist = _ref3.ignoreDist,
          ignoreDist = _ref3$ignoreDist === undefined ? false : _ref3$ignoreDist;

      var checkoutProps = {
        promptMergeOptions: interactiveMerge,
        mergeStrategy: (0, (_mergeVersion || _load_mergeVersion()).getMergeStrategy)(ours, theirs, manual),
        reset,
        all,
        verbose,
        skipNpmInstall,
        ignoreDist
      };
      return (0, (_consumer || _load_consumer()).checkout)(values, checkoutProps);
    }
  }, {
    key: 'report',
    value: function report(_ref5) {
      var components = _ref5.components,
          version = _ref5.version,
          failedComponents = _ref5.failedComponents;

      var isLatest = Boolean(version && version === (_constants || _load_constants()).LATEST);
      var isReset = !version;
      var getFailureOutput = function getFailureOutput() {
        if (!failedComponents || !failedComponents.length) return '';
        var title = 'the checkout has been canceled on the following component(s)';
        var body = failedComponents.map(function (failedComponent) {
          return `${(_chalk || _load_chalk()).default.bold(failedComponent.id.toString())} - ${(_chalk || _load_chalk()).default.red(failedComponent.failureMessage)}`;
        }).join('\n');
        return `${title}\n${body}\n\n`;
      };
      var getSuccessfulOutput = function getSuccessfulOutput() {
        if (!components || !components.length) return '';
        if (components.length === 1) {
          var component = components[0];
          var componentName = isReset ? component.id.toString() : component.id.toStringWithoutVersion();
          if (isReset) return `successfully reset ${(_chalk || _load_chalk()).default.bold(componentName)}\n`;
          var _title = `successfully switched ${(_chalk || _load_chalk()).default.bold(componentName)} to version ${(_chalk || _load_chalk()).default.bold(
          // $FlowFixMe version is defined when !isReset
          isLatest ? component.id.version : version)}\n`;
          return `${_title} ${(0, (_mergeCmd || _load_mergeCmd()).applyVersionReport)(components, false)}`;
        }
        if (isReset) {
          var _title2 = 'successfully reset the following components\n\n';
          var body = components.map(function (component) {
            return (_chalk || _load_chalk()).default.bold(component.id.toString());
          }).join('\n');
          return _title2 + body;
        }
        // $FlowFixMe version is defined when !isReset
        var versionOutput = isLatest ? 'their latest version' : `version ${(_chalk || _load_chalk()).default.bold(version)}`;
        var title = `successfully switched the following components to ${versionOutput}\n\n`;
        var showVersion = isLatest || isReset;
        var componentsStr = (0, (_mergeCmd || _load_mergeCmd()).applyVersionReport)(components, true, showVersion);
        return title + componentsStr;
      };
      var failedOutput = getFailureOutput();
      var successOutput = getSuccessfulOutput();
      return failedOutput + successOutput;
    }
  }]);

  return Checkout;
}((_command || _load_command()).default);

exports.default = Checkout;