'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _componentTemplate;

function _load_componentTemplate() {
  return _componentTemplate = _interopRequireDefault(require('../../templates/component-template'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../../error/general-error'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Show = function (_Command) {
  _inherits(Show, _Command);

  function Show() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Show);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Show.__proto__ || Object.getPrototypeOf(Show)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'show <id>', _this.description = `show component overview.\n https://${(_constants || _load_constants()).BASE_DOCS_DOMAIN}/docs/cli-show.html`, _this.alias = '', _this.opts = [['j', 'json', 'return a json version of the component'], ['r', 'remote', 'show a remote component'], ['v', 'versions', 'return a json of all the versions of the component'], ['o', 'outdated', 'show latest version from the remote scope (if exists)'], ['c', 'compare [boolean]', 'compare current file system component to latest tagged component [default=latest]']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Show, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          id = _ref4[0];

      var json = _ref3.json,
          versions = _ref3.versions,
          _ref3$remote = _ref3.remote,
          remote = _ref3$remote === undefined ? false : _ref3$remote,
          _ref3$outdated = _ref3.outdated,
          outdated = _ref3$outdated === undefined ? false : _ref3$outdated,
          _ref3$compare = _ref3.compare,
          compare = _ref3$compare === undefined ? false : _ref3$compare;

      function getBitComponent(allVersions) {
        if (remote) return (0, (_consumer || _load_consumer()).getScopeComponent)({ id, allVersions, showRemoteVersions: outdated });
        return (0, (_consumer || _load_consumer()).getConsumerComponent)({ id, compare, allVersions, showRemoteVersions: outdated });
      }

      if (versions && (compare || outdated)) {
        throw new (_generalError || _load_generalError()).default('the [--compare] or [--outdated] flag cannot be used along with --versions');
      }

      if (versions) {
        return getBitComponent(versions).then(function (components) {
          return {
            components,
            versions
          };
        });
      }
      if (compare && outdated) {
        throw new (_generalError || _load_generalError()).default('please make sure to use either [--compare] or [--outdated], alone');
      }
      return getBitComponent().then(function (_ref5) {
        var component = _ref5.component,
            componentModel = _ref5.componentModel;
        return {
          component,
          componentModel,
          json,
          outdated
        };
      });
    }
  }, {
    key: 'report',
    value: function report(_ref6) {
      var component = _ref6.component,
          componentModel = _ref6.componentModel,
          json = _ref6.json,
          versions = _ref6.versions,
          components = _ref6.components,
          outdated = _ref6.outdated;

      if (versions) {
        if ((_ramda || _load_ramda()).default.isNil(components) || (_ramda || _load_ramda()).default.isEmpty(components)) {
          return 'could not find the requested component';
        }

        // $FlowFixMe
        return JSON.stringify(components.map(function (c) {
          return c.toObject();
        }), null, '  ');
      }

      if (!component) return 'could not find the requested component';
      if (json) {
        var makeEnvFilesReadable = function makeEnvFilesReadable(env) {
          if (!env) return undefined;
          if (env.files && env.files.length) {
            var readableFiles = env.files.map(function (file) {
              return file.toReadableString();
            });
            return readableFiles;
          }
          return [];
        };

        var makeComponentReadable = function makeComponentReadable(comp) {
          if (!comp) return comp;
          var componentObj = comp.toObject();
          componentObj.files = comp.files.map(function (file) {
            return file.toReadableString();
          });
          componentObj.dists = componentObj.dists.getAsReadable();
          if (comp.compiler) {
            componentObj.compiler.files = makeEnvFilesReadable(comp.compiler);
          }
          if (comp.tester) {
            componentObj.tester.files = makeEnvFilesReadable(comp.tester);
          }
          return componentObj;
        };
        var componentFromFileSystem = makeComponentReadable(component);
        var componentFromModel = makeComponentReadable(componentModel);
        var jsonObject = componentFromModel ? { componentFromFileSystem, componentFromModel } : componentFromFileSystem;
        return JSON.stringify(jsonObject, null, '  ');
      }
      return (0, (_componentTemplate || _load_componentTemplate()).default)(component, componentModel, outdated);
    }
  }]);

  return Show;
}((_command || _load_command()).default);

exports.default = Show;