/** @flow */
import fs from 'fs';
import { AUTO_GENERATED_STAMP } from '../constants';
import type { PathOsBased } from './path';

/**
 * check if file was auto generated by bit
 *
 * @param {PathOsBased} filePath - consumer path
 * @returns {boolean}
 */
export default function isFileAutoGenerated(filePath: PathOsBased): boolean {
  const fileContent = fs.readFileSync(filePath).toString();
  return fileContent.includes(AUTO_GENERATED_STAMP);
}
